﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace RedPlus.Library
{
    public class Board
    {
        /// <summary>
        /// 주어진 문자열을 HTML 코드로 변경함. 탭/공백도 처리
        /// <br /> -> &lt;br /&gt;
        /// </summary>
        /// <param name="strContent">입력된 코드 그대로</param>
        /// <returns>HTML태그가 실행되지 않도록 인코딩</returns>
        public static string ConvertToHtml(string strContent)
        {
            string strTemp = "";
            if (strContent == null || strContent.Length == 0)
            {
                strTemp = "";
            }
            else
            {
                strTemp = strContent
                    .Replace("&", "&amp;")
                    .Replace(">", "&gt;")
                    .Replace("<", "&lt;")
                    .Replace("\r\n", "<br />")
                    .Replace("\"", "&#34;")
                    .Replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;")
                    .Replace(" " + " ", "&nbsp;&nbsp;");
            }
            return strTemp;
        }
    }
}