using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DotNetNote.Models;
using DotNetNote.Helpers; // 

namespace DotNetNote.Controllers
{   
    public class DotNetNoteController : Controller
    {
        private DotNetNoteContext context = new DotNetNoteContext();
        //[!]   ֱٱ 10 
        private const int pageSize = 10;

        //
        // GET: /DotNetNote/
        //[1] ¡ ó  ҽ
        //public ViewResult Index()
        //{
        //    // Num ʵ忡 ؼ  
        //    return View(context.DotNetNoteArticle.OrderByDescending(d => d.Num).ToList());
        //}
        //[2] ¡ ó  ҽ
        public ViewResult Index(int? page)
        {
            //[1]   ҽ
            var source = context.DotNetNoteArticle.OrderByDescending(d => d.Num);
            //[2]  ε : 0 
            // page = page ?? 0;
            //[3]   ֱٱ 10 
            //const int pageSize = 10;

            //[!]  ȣ   
            // ViewPage Ŭ TempData Ӽ  :  ѹ  û ִ ӽ  
            TempData["Page"] = page ?? 0;

            var pagedList = new PaginatedList<DotNetNoteArticle>(source, (page ?? 0), pageSize);

            return View(pagedList); // ִ 10 ڵ, /ü 
        }

        //
        // GET: /DotNetNote/Details/5

        public ViewResult Details(int id)
        {
            DotNetNoteArticle dotnetnotearticle = context.DotNetNoteArticle.Single(x => x.Num == id);

            // ȸ   ߰
            dotnetnotearticle.ReadCount++;  // ȸ 
            context.SaveChanges();          //  Ʈ

            return View(dotnetnotearticle);
        }

        //
        // GET: /DotNetNote/Create

        public ActionResult Create()
        {
            ViewData["Title"] = "Խ ۾";
            GetEncoding();

            return View();
        }

        private void GetEncoding()
        {
            SelectList encodingOptions = new SelectList(new string[] {"Text", "HTML", "Mixed"});
            ViewBag.Encoding = encodingOptions; 
        } 

        //
        // POST: /DotNetNote/Create
        [HttpPost]
        [ValidateInput(false)] // Page ù validateRequest="false"  
        public ActionResult Create(DotNetNoteArticle dotnetnotearticle)
        {
            GetEncoding();

            //    ȿ ˻  ߰
            //  ȿ ˻ : http://www.asp.net/mvc/tutorials/older-versions/models-(data)/performing-simple-validation-cs
            if (Request.Form["Name"].Trim().Length < 1)
            {
                //   : ȿ ˻ 
                ModelState.AddModelError("Name", "̸ ԷϽÿ."); 
            }
            
            if (ModelState.IsValid)
            {
                // ڷκ Է¹޴ ̿  ó
                dotnetnotearticle.PostDate = DateTime.Now; // ۼ ð ʱȭ
                dotnetnotearticle.PostIp = Request.UserHostAddress; // IPּ
                dotnetnotearticle.ReadCount = 0; // ȸ 0 ʱȭ
                
                context.DotNetNoteArticle.Add(dotnetnotearticle);
                context.SaveChanges(); //  

                return RedirectToAction("Index");  
            }

            return View(dotnetnotearticle);
        }
        
        //
        // GET: /DotNetNote/Edit/5
        public ActionResult Edit(int id)
        {
            ViewData["Title"] = " ϱ";
            GetEncoding();

            //  Է߾   ٰ  Ʈѿ ε
            DotNetNoteArticle dotnetnotearticle = context.DotNetNoteArticle.Single(x => x.Num == id);
            return View(dotnetnotearticle);
        }   

        //
        // POST: /DotNetNote/Edit/5
        [HttpPost]
        public ActionResult Edit(DotNetNoteArticle dotnetnotearticle)
        {
            ViewData["Title"] = " ϱ";
            GetEncoding();

            //  ϱ ư Ŭ   ȣ Է ȣ   ׷  ޽ 
            //  ȣ о  ο Context ü ؼ о 
            string pwd = "";
            using (DotNetNoteContext newContext = new DotNetNoteContext())
            {
                pwd = newContext.DotNetNoteArticle.Find(dotnetnotearticle.Num).Password;
            }

            if (pwd == dotnetnotearticle.Password) // ȣ ...
            {
                if (ModelState.IsValid)
                {
                    context.Entry(dotnetnotearticle).State = EntityState.Modified;

                    // ϱ  ߰Ǵ ʵ
                    dotnetnotearticle.ModifyDate = DateTime.Now; //   ¥ Ʈ
                    dotnetnotearticle.ModifyIp = Request.UserHostAddress; //   IPּ

                    context.SaveChanges();
                    return RedirectToAction("Index");
                }
                return View(dotnetnotearticle);
            }
            else // ȣ Ʋ
            {
                // ޽ 
                ModelState.AddModelError("Password", "ȣ Ʋϴ. ٽ Էϼ...");
                return View(dotnetnotearticle);
            }            
        }

        //
        // GET: /DotNetNote/Delete/5
        public ActionResult Delete(int id)
        {
            //    
            //DotNetNoteArticle dotnetnotearticle = context.DotNetNoteArticle.Single(x => x.Num == id);
            DotNetNoteArticle dotnetnotearticle = context.DotNetNoteArticle.Find(id);
            if (dotnetnotearticle == null)
            {
                return View("NotFound"); // ߸ ûԴϴ... ǥ
            }
            return View(dotnetnotearticle);
        }

        //
        // POST: /DotNetNote/Delete/5
        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {
            ViewData["Title"] = " ϱ";

            //  ϱ ư Ŭ   ȣ Է ȣ   ׷   ޽ 
            //  ȣ о  ο Context ü ؼ о 
            string pwd = "";
            using (DotNetNoteContext newContext = new DotNetNoteContext())
            {
                //pwd = newContext.DotNetNoteArticle.Find(id).Password;
                DotNetNoteArticle dnna = newContext.DotNetNoteArticle.Find(id);
                if (dnna == null) // Ѱܿ id شϴ Ͱ ٸ...
                {
                    return View("NotFound"); // ߸ ûԴϴ... ǥ
                }
                else
                {
                    pwd = dnna.Password; //  ȣ ӽ 
                }
            }

            DotNetNoteArticle dotnetnotearticle = context.DotNetNoteArticle.Single(x => x.Num == id);
            if (pwd == Request.Form["Password"]) // ȣ ...
            {
                try
                {
                    context.DotNetNoteArticle.Remove(dotnetnotearticle);
                    context.SaveChanges();
                    //return RedirectToAction("Index"); //   Ʈ ̵
                    return RedirectToAction("Deleted"); //  ó Ϸ 
                }
                catch (Exception)
                {
                    return View();
                }
            }
            else
            {
                ModelState.AddModelError("Password", "ȣ Ʋϴ. ٽ Էϼ...");
                return View(dotnetnotearticle);
            }
        }

        //  Ϸ ó 
        public ActionResult Deleted()
        {
            return View();
        }

        // ˻  Ʈ  : ¡ ߰
        public ActionResult Search(string searchField, string searchQuery, int? page)
        {
            // ǿ  ˻
            IQueryable<DotNetNoteArticle> find; // ˻  Ʈ  
            switch (searchField)
            {
                case "Name": // ۼ 
                    // LINQ : Query Expression
                    find = from dnn in context.DotNetNoteArticle
                           where dnn.Name.Contains(searchQuery) // Name Like 'ȫ浿%'
                           orderby dnn.Num descending
                           select dnn;
                    break;
                case "Title": // 
                    // LINQ : Query Operator
                    find = context.DotNetNoteArticle
                        .Where(d => d.Title.Contains(searchQuery))
                        .OrderByDescending(d => d.Num);
                    break;
                case "Content": // 
                    find = context.DotNetNoteArticle
                        .Where(d => d.Content.Contains(searchQuery))
                        .OrderByDescending(d => d.Num);
                    break;
                default: // -ü-
                    find = from dnn in context.DotNetNoteArticle
                           where
                            dnn.Name.Contains(searchQuery) // Name Like 'ȫ浿%'
                            ||
                            dnn.Title.Contains(searchQuery) // Title Like 'ȫ浿%'
                            ||
                            dnn.Content.Contains(searchQuery) // Content Like 'ȫ浿%'
                           orderby dnn.Num descending
                           select dnn;
                    break;
            }

            var pagedList = new PaginatedList<DotNetNoteArticle>(find, (page ?? 0), pageSize);

            return View(pagedList); // ִ 10 ڵ, /ü 
        }

        // ˻  Ʈ  
        //public ActionResult Search(string searchField, string searchQuery)
        //{ 
        //    // ǿ  ˻
        //    IQueryable<DotNetNoteArticle> find; // ˻  Ʈ  
        //    switch (searchField)
        //    {
        //        case "Name": // ۼ 
        //            // LINQ : Query Expression
        //            find = from dnn in context.DotNetNoteArticle
        //                   where dnn.Name.Contains(searchQuery) // Name Like 'ȫ浿%'
        //                   orderby dnn.Num descending
        //                   select dnn;
        //            break;
        //        case "Title": // 
        //            // LINQ : Query Operator
        //            find = context.DotNetNoteArticle
        //                .Where(d => d.Title.Contains(searchQuery))
        //                .OrderByDescending(d => d.Num);
        //            break;
        //        case "Content": // 
        //            find = context.DotNetNoteArticle
        //                .Where(d => d.Content.Contains(searchQuery))
        //                .OrderByDescending(d => d.Num);
        //            break;
        //        default: // -ü-
        //            find = from dnn in context.DotNetNoteArticle
        //                   where
        //                    dnn.Name.Contains(searchQuery) // Name Like 'ȫ浿%'
        //                    ||    
        //                    dnn.Title.Contains(searchQuery) // Title Like 'ȫ浿%'
        //                    ||
        //                    dnn.Content.Contains(searchQuery) // Content Like 'ȫ浿%'
        //                   orderby dnn.Num descending
        //                   select dnn;
        //            break;
        //    }

        //    return View(find.ToList()); 
        //}

        
        // jQuery UI autocomplete term=ȫ浿, ...
        public ActionResult SearchAutocomplete(string term)
        { 
            // ǿ  ˻
            var find = from dnn in context.DotNetNoteArticle
                   where
                    //dnn.Name.ToLower().Contains(term.ToLower()) // Name Like 'ȫ浿%'
                    //||
                    dnn.Title.ToLower().StartsWith(term.ToLower()) // Title Like 'ȫ浿%'
                   orderby dnn.Num descending
                   select dnn.Title; // ˻

            return Json(find.Take(10).ToList(), JsonRequestBehavior.AllowGet);
        }

    }
}