﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace DotNetNote
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            // 페이징 처리 관련 라우팅 규칙 추가
            routes.MapRoute(
                "DotNetNote",                                           // 별칭
                "DotNetNote/Page/{page}",                               // URL 라우팅 정의
                new { controller = "DotNetNote", action = "Index" }     // 컨트롤러와 액션 메서드 정의
            );
            routes.MapRoute(
                "DotNetNoteIndex",                                      // 별칭
                "DotNetNote/Index/Page/{page}",                         // URL 라우팅 정의
                new { controller = "DotNetNote", action = "Index" }     // 컨트롤러와 액션 메서드 정의
            );
            // 검색 페이지의 페이징 처리 관련 라우팅 규칙 추가
            routes.MapRoute(
                "DotNetNoteSearch",                                      // 별칭
                "DotNetNote/Search/Page/{page}",                         // URL 라우팅 정의
                new { controller = "DotNetNote", action = "Search" }     // 컨트롤러와 액션 메서드 정의
            );

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );

        }

        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}