﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;

namespace DotNetNote.Models
{
    // 본 내용에 대한 교과서 다운 영어 표현 : Extending Model Classes to Add Business Rules
    [MetadataType(typeof(DotNetNoteArticle_Validation))]
    public partial class DotNetNoteArticle
    {
        // 현재 클래스는 밖으로 이동해도 됨. 관리상 같이 묶어 놓음.
        public class DotNetNoteArticle_Validation // 좀 더 좋은 이름은 DotNetNoteArticleMetadata
        {
            // UNIQUE
            [Key]
            public int Num { get; set; }

            // 5W1H
            [Display(Name="이름")] 
            [Required(ErrorMessage = "이름을 입력하시오."), StringLength(25, MinimumLength = 1)]
            public string Name { get; set; }            // 누가(Who)
            [Display(Name="작성일")]
            public DateTime? PostDate { get; set; }     // 언제(When)
            [StringLength(15, ErrorMessage="IP주소가 15자를 넘지 않겠죠???", MinimumLength=3)]
            public string PostIp { get; set; }          // 어디서(Where)
            [Required(ErrorMessage = "제목을 입력하시오."), StringLength(150, MinimumLength = 1)]
            [Display(Name="제목")]
            public string Title { get; set; }           // 무엇을(What)
            [Display(Name = "내용")]
            [Required(ErrorMessage = "내용을 입력하시오.")]
            public string Content { get; set; }         // 어떻게(How)
            [Display(Name = "태그")]
            [System.ComponentModel.DisplayName("Tags")]
            public string Tags { get; set; }            // 왜(Why)

            // Users : UID로 초기화 가능
            [Required(ErrorMessage = "암호를 입력하시오.")]
            [StringLength(25)]
            [Display(Name = "암호")]
            public string Password { get; set; }
            [RegularExpression(@"^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$", ErrorMessage = "이메일을 정확히 입력하시오.")]
            [StringLength(50)]
            //[DataType(DataType.EmailAddress)]
            [Display(Name = "이메일")]
            public string Email { get; set; }
            [RegularExpression(@"((mailto\:|(news|(ht|f)tp(s?))\://){1}\S+)", ErrorMessage = "홈페이지를 정확히 입력하시오.")]
            [StringLength(255)]
            [Display(Name = "홈페이지")]
            public string Homepage { get; set; }

            // Boards
            //[Range(0, 2100000000, ErrorMessage="")]
            public int ReadCount { get; set; }          // 조회수
            [Required]
            [StringLength(15)]
            [Display(Name = "인코딩")]
            public string Encoding { get; set; }        // 인코딩(Text/Html)
            [DisplayFormat(DataFormatString="{0:d}")]
            public DateTime? ModifyDate { get; set; }   // 수정한 날짜
            [StringLength(15)]
            public string ModifyIp { get; set; }        // 수정한 IP

            // File : 자료실로 업그레이드

            // Reply : 답변형으로 업그레이드

        }
    }
}